﻿using UnityEngine;
using System.Collections;

public class enemyHealth : MonoBehaviour {

	//the death animation that spawns if he dies
	public GameObject deathAnim;
	//a heart that might drop when he dies
	public GameObject heartDrop;
	public int health = 6;
	public AudioClip hurtSound;
	
	private SpriteRenderer rend;
	private bool isDead = false;
	
	void Start () {
		rend = GetComponent<SpriteRenderer>();
	}
	
	//here we manage health of the enemy when a bullet hits it. if its health is 0 it will spawn the death animation, possibly spawn a heart, then destroy itself.
	void takeDamage (float amount) {
		if(!isDead){
			audio.PlayOneShot(hurtSound);
			health -= 1;
			if(health <= 0){
				isDead = true;
				Instantiate(deathAnim, transform.position, Quaternion.Euler(0,180,0));
				int randNum = Random.Range(1,4);
				if(randNum == 2){
					Instantiate(heartDrop, transform.position, Quaternion.Euler(0,180,0));
				}
				Destroy(gameObject);
			}else{
				StartCoroutine(resetColor());
			}
		}
	}
	
	//called when hit to show that the enemy was hit
	public IEnumerator resetColor () {
		rend.color = new Vector4(1.0f,0.25f,0.25f,1.0f);
		yield return new WaitForSeconds (0.125f);
		rend.color = new Vector4(1.0f,1.0f,1.0f,1.0f);
	}
}
