﻿using UnityEngine;
using System.Collections;

public class pauseManager : MonoBehaviour {

	public GUITexture pauseButton;
	public GUIText resumeButton;
	public GUIText menuButton;
	public GUIText quitButton;
	public GUITexture darken;
	
	private bool isPaused = false;
	
	void Start () {
		resumeButton.guiText.enabled = false;
		menuButton.guiText.enabled = false;
		quitButton.guiText.enabled = false;
		darken.guiTexture.enabled = false;
	}
	
	void Update () {
		if(Input.GetKeyDown(KeyCode.Escape)){
			doPause();
		}
	}
	
	void doPause () {
		if(isPaused){
			Time.timeScale = 1.0f;
			resumeButton.guiText.enabled = false;
			menuButton.guiText.enabled = false;
			quitButton.guiText.enabled = false;
			darken.guiTexture.enabled = false;
			isPaused = false;
		}else{
			Time.timeScale = 0.0f;
			resumeButton.guiText.enabled = true;
			menuButton.guiText.enabled = true;
			quitButton.guiText.enabled = true;
			darken.guiTexture.enabled = true;
			isPaused = true;
		}
	}
	
	void doResume () {
		doPause();
	}
	
	void doMenu () {
		Application.LoadLevel("menu");
	}
	
	void doQuit () {
		Application.Quit();
	}
}
