﻿using UnityEngine;
using System.Collections;

public class playerAnimator : MonoBehaviour {

	//here we have all of the player's textures to animate him running and being idle. jumping just uses the idle texture.
	public Sprite[] idle;
	public float idleFrameRate = 8.0f;
	public Sprite[] run;
	public float runFrameRate = 8.0f;
	public Sprite[] jump;
	public float jumpFrameRate = 8.0f;
	public float frameRate = 8;
	
	//here are some private variables we use to help animate the character.
	private CharacterController controller;
	private float counter = 0.0f;
	private int i = 0;
	private SpriteRenderer rend;
	private bool isJumping = false;
	
	void Start () {
		controller = GetComponent<CharacterController>();
		rend = GetComponent<SpriteRenderer>();
	}
	
	void Update () {
		//Check velocity to see if player should do idle or run animation
		float xVelocity = controller.velocity.x;
		float yVelocity = controller.velocity.y;
		if(xVelocity < 0){
			xVelocity *= -1;
		}
		if(xVelocity < 0.25f){
			//Do Idle
			if(controller.isGrounded){
				counter += Time.deltaTime*idleFrameRate;
				if(counter > i && i < idle.Length){
					//Apply texture from sprite array based on time
					rend.sprite = idle[i];
					i += 1;
				}
				//Reset counter and i so animation loops seamlessly
				if(counter > idle.Length){
					counter = 0.0f;
					i = 0;
				}
			}
		}else{
			if(controller.isGrounded){
				//Do Run
				counter += Time.deltaTime*runFrameRate;
				if(counter > i && i < run.Length){
					//Apply texture from sprite array based on time
					rend.sprite = run[i];
					i += 1;
				}
				if(counter > run.Length){
					//Reset counter and i so animation loops seamlessly
					counter = 0.0f;
					i = 0;
				}
			}
		}
		if(!controller.isGrounded){
			//Do Jump
			if(!isJumping && yVelocity > 0.5f){
				isJumping = true;
				counter = 0.0f;
				i = 0;
			}
			if(isJumping){
				counter += Time.deltaTime*jumpFrameRate;
				if(counter > i && i < jump.Length){
					rend.sprite = jump[i];
					i += 1;
				}
			}
		}
		if(controller.isGrounded){
			isJumping = false;
		}
	}
}
