#pragma strict

//here are the star textures that make a "stylized" explosion. this is used on both enemies and the player on death.
var deathSprites:Sprite[];
//we also want to multiply the counter by a number to get a specific framerate
var frameRate:float = 12.0;
//death sound
var deathSound:AudioClip;
//we want to set a counter so the animation can be based on time
private var counter:float = 0.0;
private var i:int = 0;
private var rend:SpriteRenderer;

function Start () {
rend = GetComponent(SpriteRenderer);
//play the death sound once as soon as this object is spawned
audio.PlayOneShot(deathSound);
}

function Update () {
	//keeping track of time with counter
	counter += Time.deltaTime*frameRate;
	if(counter > i && i < deathSprites.Length){
		rend.sprite = deathSprites[i];
		i += 1;
	}
	//If animation finishes, we destroy the object
	if(counter > deathSprites.Length){
		Destroy(gameObject);
	}
}