﻿#pragma strict

//the death animation that spawns if he dies
var deathAnim:GameObject;
//a heart that might drop when he dies
var heartDrop:GameObject;
var health:int = 6;
var hurtSound:AudioClip;

private var rend:SpriteRenderer;

function Start () {
	rend = GetComponent(SpriteRenderer);
}

//here we manage health of the enemy when a bullet hits it. if its health is 0 it will spawn the death animation, possibly spawn a heart, then destroy itself.
function takeDamage (amount : float) {
	audio.PlayOneShot(hurtSound);
	resetColor();
	health -= 1;
	if(health <= 0){
		Instantiate(deathAnim, transform.position, Quaternion.Euler(0,180,0));
		var randNum:int = Random.Range(1,4);
		if(randNum == 2){
			Instantiate(heartDrop, transform.position, Quaternion.Euler(0,180,0));
		}
		Destroy(gameObject);
	}
}

//called when hit to show that the enemy was hit
function resetColor () {
	rend.color.g = 0.25;
	rend.color.b = 0.25;
	yield WaitForSeconds(0.125);
	rend.color.g = 1;
	rend.color.b = 1;
}