#pragma strict

//public variables we use to make the floater characters
//sound for when its hurt
var hurtSound:AudioClip;
//the textures of the floater
var floatAnimation:Sprite[];
//animation frame rate
var frameRate:float = 6.0;
var moveSpeed:float = 16.0;
var moveAccuracy:float = 1.0;

//private variables that we use to help animate the floater
private var controller:CharacterController;
private var rend:SpriteRenderer;
private var counter:float = 0.0;
private var i:int = 0;
private var target:GameObject;
private var distance:float = 0.0;
private var ydistance:float = 0.0;
private var origX:float;

//we use the player to help animate the floater enemy by using the player's position.
function Start () {
	controller = GetComponent(CharacterController);
	rend = GetComponent(SpriteRenderer);
	target = GameObject.Find("Player");
	Physics.IgnoreCollision(target.collider, collider);
	origX = transform.localScale.x;
	//here it makes it ignore other enemy colliders so they can't get caught on each other.
	var enemies = GameObject.FindGameObjectsWithTag("enemy");
	for (var en : GameObject in enemies)  {
		if (en.collider != collider) {
			Physics.IgnoreCollision(collider, en.collider);
		}
	}
}

function Update () {
	//here we check the distance the player is from the floater.
	distance = target.transform.position.x - transform.position.x;
	ydistance = target.transform.position.y - transform.position.y;
	if(distance < 0){
		distance *= -1;
	}
	if(ydistance < 0){
		ydistance*= -1;
	}
	//here we check if the floater is to the left or to the right of the player so we can decide which textures to use while he's floating to make him look like he's looking at the player
	if(controller.velocity.x > 0){
		transform.localScale.x = origX;
	}
	if(controller.velocity.x < 0){
		transform.localScale.x = -origX;
	}

	//if the player is close enough, start animating and moving.
	if(distance < 16 && ydistance < 8){
		counter += Time.deltaTime*frameRate;
		if(counter > i && i < floatAnimation.Length){
			rend.sprite = floatAnimation[i];
		}
		if(counter > floatAnimation.Length){
			counter = 0.0;
			i = 0;
		}
	}

	//this is how we get the floating to always move towards the player if he's close enough.
	if(target != null){
		var dir = target.transform.position - transform.position;
		dir = dir.normalized;
		controller.Move(Vector3.Lerp(controller.velocity, dir*moveSpeed, moveAccuracy*Time.deltaTime)*Time.deltaTime);
	}
}
