#pragma strict

//heres some variables that we use to make the jumper character
//here are the textures that make the jumper look like an enemy
var idle:Sprite[];
var idleFrameRate:float = 8.0;
var jump:Sprite[];
var jumpFrameRate:float = 8.0;
var jumpRate:float = 2.0;
var jumpHeight:float = 19.0;

//here are some private variables that we use to help animate the enemy
private var controller:CharacterController;
private var rend:SpriteRenderer;
private var target:GameObject;
private var jumpCounter:float = 0.0;
private var vel:Vector3;
private var jumping = true;
private var distance:float = 0.0;
private var ydistance:float = 0.0;
private var playerDist:float = 0.0;
private var origX:float = 0.0;
private var counter:float = 0.0;
private var i:int = 0;


function Start () {
	controller = GetComponent(CharacterController);
	rend = GetComponent(SpriteRenderer);
	origX = transform.localScale.x;
	//here we set the player as the target to help give the jumper behaviors. Pretty much simple AI.
	target = GameObject.Find("Player");
	Physics.IgnoreCollision(target.collider, collider);
	//here it makes it ignore other enemy colliders so they can't get caught on each other.
	var enemies = GameObject.FindGameObjectsWithTag("enemy");
	for (var en : GameObject in enemies)  {
		if (en.collider != collider) {
			Physics.IgnoreCollision(collider, en.collider);
		}
	}
}

function Update () {
	//check if the controller is grounded, otherwise apply gravity with time.deltatime
	if(controller.isGrounded){
		vel.y = -1;
		if(jumping){
			jumping = false;
		}
		vel.x = 0;
	}else{
		vel.y -= Time.deltaTime*80;
	}
	//here we check the distance the player is away from the jumper
	distance = target.transform.position.x - transform.position.x;	
	ydistance = target.transform.position.y - transform.position.y;
	if(distance < 0){
		distance *= -1;
	}
	if(ydistance < 0){
		ydistance*= -1;
	}
	if(target.transform.position.x < transform.position.x){
		transform.localScale.x = -origX;
	}
	if(target.transform.position.x > transform.position.x){
		transform.localScale.x = origX;
	}

	//if the player is close enough, the enemy can now do its thing like animate and jump towards the player
	if(distance < 16 && ydistance < 8){
		jumpCounter += Time.deltaTime;
		if(jumpCounter < jumpRate && !jumping){
			counter += Time.deltaTime*idleFrameRate;
			if(counter > i && i < idle.Length){
				rend.sprite = idle[i];
			}
			if(counter > idle.Length){
				counter = 0.0;
				i = 0;
			}
		}

		//here we jump towards the player at a velocity relative to distance. only if the jumpCounter hits jumpspeed. otherwise the enemy will jump all over the place like crazy and likely be useless... and funny.
		if(jumpCounter > jumpRate){
			playerDist = target.transform.position.x-transform.position.x;
			jumpCounter = 0.0;
			jumping = true;
			vel.y = jumpHeight;
		}
	}
	
	if(jumping){
		counter += Time.deltaTime*jumpFrameRate;
		if(counter > i && i < jump.Length){
			rend.sprite = jump[i];
		}
	}

	//here we make the jump move towards the player
	if(controller.velocity.y > 0.5){
		vel.x = playerDist*1.5;
	}

	//if the jumper falls down a hole we want to destroy it so that it doesn't continue to exist for no reason. he's not coming back.
	if(transform.position.y < -10){
		Destroy(gameObject);
	}
	//Apply movement to the enemy	
	controller.Move(vel*Time.deltaTime);
}
