#pragma strict

//here we have all of the player's textures to animate him running and being idle. jumping just uses the idle texture.
var idle:Sprite[];
var idleFrameRate:float = 8.0;
var run:Sprite[];
var runFrameRate:float = 8.0;
var jump:Sprite[];
var jumpFrameRate:float = 8.0;
var frameRate:float = 8;

//here are some private variables we use to help animate the character.
private var controller:CharacterController;
private var counter:float = 0.0;
private var i:int = 0;
private var rend:SpriteRenderer;
private var isJumping = false;

function Start () {
	controller = GetComponent(CharacterController);
	rend = GetComponent(SpriteRenderer);
}

function Update () {
	//Check velocity to see if player should do idle or run animation
	var xVelocity = controller.velocity.x;
	var yVelocity = controller.velocity.y;
	if(xVelocity < 0){
		xVelocity *= -1;
	}
	if(xVelocity < 0.25){
		//Do Idle
		if(controller.isGrounded){
			counter += Time.deltaTime*idleFrameRate;
			if(counter > i && i < idle.Length){
				//Apply texture from sprite array based on time
				rend.sprite = idle[i];
				i += 1;
			}
			//Reset counter and i so animation loops seamlessly
			if(counter > idle.Length){
				counter = 0.0;
				i = 0;
			}
		}
	}else{
		if(controller.isGrounded){
			//Do Run
			counter += Time.deltaTime*runFrameRate;
			if(counter > i && i < run.Length){
				//Apply texture from sprite array based on time
				rend.sprite = run[i];
				i += 1;
			}
			if(counter > run.Length){
				//Reset counter and i so animation loops seamlessly
				counter = 0.0;
				i = 0;
			}
		}
	}
	if(!controller.isGrounded){
			//Do Jump
			if(!isJumping && yVelocity > 0.5){
				isJumping = true;
				counter = 0.0;
				i = 0;
			}
			if(isJumping){
				counter += Time.deltaTime*jumpFrameRate;
				if(counter > i && i < jump.Length){
					rend.sprite = jump[i];
					i += 1;
				}
			}
		}
	if(controller.isGrounded){
		isJumping = false;
	}
//end of function update
}